Conteúdo
Índice 🔎︎

# GoSub...Return Statement

Calls a subroutine that is indicated by a label inside a Sub or a Function. The statements following the label are executed until the next Return statement. Afterwards, the program continues with the statement that follows the GoSub statement.

### Sintaxe:

    GoSub label[:]

### Parâmetros:

label: A line identifier indicating where to continue execution. The scope of a label in that of the routine it belongs to.

The GoSub statement calls a local subroutine indicated by a label from within a subroutine or a function. The name of the label must end with a colon (":").

      Sub/Function foo
          ' statements
          GoSub label
          ' statements
          Exit Sub/Function
      label:
          ' statements
          Return
      End Sub/Function

Se o programa encontrar uma instrução Return que não seja precedida por GoSub, o LibreOffice Basic devolve uma mensagem de erro. Utilize Exit Sub ou Exit Function para garantir que o programa abandona uma Sub ou Função antes de atingir a próxima instrução Return.

O seguinte exemplo demonstra a utilização das instruções GoSub e Return. Ao executar uma secção do programa duas vezes, o programa calcula a raiz quadrada de dois números inseridos pelo utilizador.

### Exemplo:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox("Introduza o primeiro número: ","Entrada de número"))
        iInputb = Int(InputBox("Introduza o segundo número: ","Entrada de número"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "A raiz quadrada de";iInputa;" é";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "A raiz quadrada de";iInputb;" é";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub

Tópicos relacionados

GoTo Statement

On...GoSub Statement; On...GoTo Statement